<template>
  <div class="min-h-full flex flex-col justify-center py-12 sm:px-6 lg:px-8">

    <div class="mt-8 sm:mx-auto sm:w-full sm:max-w-md">
      <div class="bg-white py-8 px-4 shadow sm:rounded-lg sm:px-10">
        <form class="space-y-6" @submit.prevent="createMission">
          <div>
            <label for="name" class="block text-sm font-medium text-gray-700">Mission Name</label>
            <div class="mt-1">
              <input v-model="name" id="name" name="name" type="text" required 
              class="appearance-none block w-full px-3 py-2 border border-gray-300 rounded-md 
                shadow-sm placeholder-gray-400 focus:outline-none focus:ring-blue-600
                focus:border-blue-600 sm:text-sm">
            </div>
          </div>

          <div>
            <label for="size-x" class="block text-sm font-medium text-gray-700">Plateau Size X</label>
            <div class="mt-1">
              <input v-model="size_x" id="size-x" name="size-x" type="number" required 
              class="appearance-none block w-full px-3 py-2 border border-gray-300 rounded-md 
                shadow-sm placeholder-gray-400 focus:outline-none focus:ring-blue-600
                focus:border-blue-600 sm:text-sm">
            </div>
          </div>

          <div>
            <label for="size-y" class="block text-sm font-medium text-gray-700">Plateau Size Y</label>
            <div class="mt-1">
              <input v-model="size_y" id="size-y" name="size-y" type="number" required 
              class="appearance-none block w-full px-3 py-2 border border-gray-300 rounded-md 
                shadow-sm placeholder-gray-400 focus:outline-none focus:ring-blue-600
                focus:border-blue-600 sm:text-sm">
            </div>
          </div>

          <div>
            <label for="rovers-quantity" class="block text-sm font-medium text-gray-700">Rovers Quantity</label>
            <div class="mt-1">
              <input v-model="quantity" id="rovers-quantity" name="rovers-quantity" type="number" required 
              class="appearance-none block w-full px-3 py-2 border border-gray-300 rounded-md 
                shadow-sm placeholder-gray-400 focus:outline-none focus:ring-blue-600
                focus:border-blue-600 sm:text-sm">
            </div>
          </div>

          <div>
            <button type="submit" 
            class="w-full flex justify-center py-2 px-4 border border-transparent rounded-md 
              shadow-sm text-sm font-medium text-white bg-blue-600
            hover:bg-blue-700 focus:outline-none focus:ring-2 focus:ring-offset-2 
            focus:ring-blue-600">
              Create Mission
            </button>
          </div>
        </form>
        <!-- Errors section  -->
        <div class="pt-4">
          <p class="p-1 text-red-600 font-bold" v-for="(error, errorIdx) in errors" :key="errorIdx">
            {{ error[0] }}
          </p>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  data(){
    return {
      name:'',
      size_x:'',
      size_y:'',
      quantity:'',
      errors:''
    }
  },
  methods: {
    createMission(){
      this.errors = ''
      const data = {
        "mission_name": this.name,
        "plateau_size_x": this.size_x,
        "plateau_size_y": this.size_y,
        "rovers_number": this.quantity
      }
      this.$axios.post('mission-config/',data)
        .then((response) => {
          this.$router.push(`${response.data.id}/`)
        })
        .catch((error) => {
          this.errors = error.response.data
        })
    }
  }
}
</script>